unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles, NkMemIniFile, Math,
  SystemUnit,
//  StringUnitHeavy,
//  StringUnitLight,
  AnsiStringFileUnit,
  StringUnit,
  FileUnit,
  XPtest;

type
  TCustomIniFileClass = class of TCustomIniFile;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Memo2: TMemo;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    procedure IniReadTest(Ini: TCustomIniFile);
    procedure IniUpdateFileTest(Ini: TCustomIniFile);
    { Private 錾 }
  public
  end;

procedure DoubleMemoCheck;

var
  Form1: TForm1;

implementation

uses IniFilEX, AccessIniFile, testIniFileReadStringUnit, testIniWriteStringUnit,
  testIniFileOtherUnit, testIniSectionsUnit, testIniCompareUnit,
  testIniValueUnit;

{$R *.dfm}

procedure MakeTestIniFile;
var
  IniText: String;
  StrList: TStringList;
begin
  IniText := '';
  StrList := TStringList.Create;
  StrList.Add(';RgeXg');
  StrList.Add(' ;RgeXg');
  StrList.Add(';Rg=eXg');
  StrList.Add(' ;Rg=eXg');
  StrList.Add('seLXgeXg');
  StrList.Add(' seLXgeXg');
  StrList.Add('seLXg=eXg');
  StrList.Add(' seLXg=eXg');
  StrList.Add('');
//  StrList.Add('[]');
  StrList.Add('[Option1]');
  StrList.Add('Name1=Value1-1');
  StrList.Add('Name2=Value1-2');
  StrList.Add('');
  StrList.Add(' seLXg=eXg');
  StrList.Add('seLXg=eXg');
  StrList.Add(' ;Rg=eXg');
  StrList.Add(';RgeXg');
//  StrList.Add('[]');            {TIniFile͋ZNVReadSections~}
  StrList.Add(' seLXg=eXg');
  StrList.Add('seLXg=eXg');
  StrList.Add('');
  StrList.Add('[Option2]');
  StrList.Add('Name1=Value2-1');
  StrList.Add('Name2=Value2-2');
  StrList.Add('');
  StrList.Add('seLXg=eXg');
  StrList.Add(' seLXg=eXg');
  StrList.Add('seLXgeXg');
  StrList.Add(' seLXgeXg');
  StrList.Add(';RgeXg');
  StrList.Add(' ;RgeXg');
  StrList.Add(';Rg=eXg');
  StrList.Add(' ;Rg=eXg');
  StrList.Add('[]');
  StrList.Add('seLXg=eXg');
  StrList.Add(' seLXg=eXg');
  StrList.Add('seLXgeXg');
  StrList.Add(' seLXgeXg');
  StrList.Add(';Rg=eXg');
  StrList.Add(' ;Rg=eXg');
  StrList.Add(';RgeXg');
  StrList.Add(' ;RgeXg');

  StrList.Add('[Option3]');
  StrList.Add('Name1=Value3-1');
//  StrList.Add('[]');
  StrList.Add('Name2=Value3-2');
  StrList.Add('');
  StrList.Add(';Rg=eXg');
  StrList.Add(' ;Rg=eXg');
  StrList.Add('seLXgeXg');
  StrList.Add(' seLXgeXg');
  StrList.Add('seLXg=eXg');
  StrList.Add(' seLXg=eXg');
  StrList.Add(';RgeXg');
  StrList.Add(' ;RgeXg');
  StrList.Add('[]');

  StrList.SaveToFile(ChangeFileExt(Application.ExeName, '.ini'));
  StrList.Free;
end;

procedure TForm1.IniReadTest(Ini: TCustomIniFile);
var
  SL: TStringList;
begin
  Memo1.Clear;
  Memo1.Lines.Add(Ini.ClassName+' ReadTest');
    Memo1.Lines.Add(
      Ini.ReadString('Option1', 'Name1', '') );
    Memo1.Lines.Add(
      Ini.ReadString('Option1', 'Name2', '') );
    SL := TStringList.Create;
    Ini.ReadSections(SL);
    Memo1.Lines.AddStrings(SL);
    Ini.ReadSection('Option2', SL);
    Memo1.Lines.AddStrings(SL);
    Ini.ReadSectionValues('Option2', SL);
    Memo1.Lines.AddStrings(SL);
end;

procedure TForm1.IniUpdateFileTest(Ini: TCustomIniFile);
var
  SL: TStringList;
begin
  Memo1.Lines.Add(Ini.ClassName+' UpdateFileTest');
    Ini.WriteString('Option1', 'Name1', 'VALUE2');
    Ini.WriteString('Option1', 'Name2', 'VALUE1');
    Ini.WriteString('Option1', 'Name3', 'VALUE3');
    Ini.WriteString('Option3', 'Name3', 'VALUE3-3');
    Ini.WriteString('OptionZ', 'NameA', 'VALUEA');
    Ini.DeleteKey('Option1', 'Name2');
    Ini.EraseSection('Option2');
    SL := TStringList.Create;
    Ini.ReadSections(SL);
    Memo1.Lines.AddStrings(SL);
    Ini.ReadSection('Option3', SL);
    Memo1.Lines.AddStrings(SL);
    Ini.ReadSectionValues('Option3', SL);
    Memo1.Lines.AddStrings(SL);
    Ini.UpdateFile;
end;



procedure TForm1.Button1Click(Sender: TObject);
var
  Ini: TCustomIniFile;
begin
  MakeTestIniFile;
  Ini := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    IniReadTest(Ini);
    IniUpdateFileTest(Ini);
  finally
    Ini.Free;
  end;
  Memo2.Lines.LoadFromFile(ChangeFileExt(Application.ExeName, '.ini'));
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Ini: TCustomIniFile;
begin
  MakeTestIniFile;
  Ini := TMemIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    IniReadTest(Ini);
    IniUpdateFileTest(Ini);
  finally
    Ini.Free;
  end;
  Memo2.Lines.LoadFromFile(ChangeFileExt(Application.ExeName, '.ini'));
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  Ini: TCustomIniFile;
begin
  MakeTestIniFile;
  Ini := TNkMemIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    IniReadTest(Ini);
    IniUpdateFileTest(Ini);
  finally
    Ini.Free;
  end;
  Memo2.Lines.LoadFromFile(ChangeFileExt(Application.ExeName, '.ini'));
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  Ini: TCustomIniFile;
begin
  MakeTestIniFile;
  Ini := TIniFileEX.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    IniReadTest(Ini);
    IniUpdateFileTest(Ini);
  finally
    Ini.Free;
  end;
  Memo2.Lines.LoadFromFile(ChangeFileExt(Application.ExeName, '.ini'));
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  Ini: TCustomIniFile;
begin
  MakeTestIniFile;
  Ini := TAccessIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
  try
    IniReadTest(Ini);
    IniUpdateFileTest(Ini);
  finally
    Ini.Free;
  end;
  Memo2.Lines.LoadFromFile(ChangeFileExt(Application.ExeName, '.ini'));
end;


////////////////////////////////////////////////////////////


procedure DoubleMemoCheck;
var
  i: Integer;
begin
  UnitTest.Initialize;
  with Form1 do
  for i := 0 to Min(Memo1.Lines.Count, Memo2.Lines.Count) - 1 do
  begin
    UnitTest.Check(Memo1.Lines[i], Memo2.Lines[i]);
  end;
  UnitTest.Finalize;
  ShowMessage(UnitTest.LogText);
end;




////////////////////////////////////////////////////////////

procedure TForm1.Button6Click(Sender: TObject);
begin
  testIniValue;
  testIniCompare;

  testIniFileReadString;
  testIniWriteString;

  testIniSections;
  testIniFileOther;
end;

end.
