unit testIniCompareUnit;

interface

uses
  Windows,
  Classes,
  SysUtils,
  IniFiles,
  Dialogs,
  Math,
  Clipbrd,

  FileUnit,
//  StringUnitHeavy,
  AnsiStringFileUnit,
  ExePathUnit,
  SystemUnit,
  XPtest;

procedure testIniCompare;

implementation

uses AccessIniFile, Unit1;

procedure testIniFileCreateCRLF;

    function MakeTestIniFileCreateCRLF(Ini: TCustomIniFile): String;
    begin
      Ini.WriteString('test', 'test1', '');
      Ini.WriteString('test', 'test2', '""');
      Ini.WriteString('test', 'test3', '''''''');
//      Ini.WriteString('test', 'test4', ''#13''#10'Ă');
      Ini.WriteString('test', 'test4', ''#13#10''#13#10'Ă');
      Ini.WriteString('test', 'test5', ''#13#10'ɂʂ'#13#10'');
//      Ini.WriteString('test', 'test6', ''#13''#10'Ă');
      Ini.WriteString('test', 'test6', ''#13#10''#13#10'Ă');
      Ini.WriteString('test', 'test6', ''#13#10'ɂʂ'#13#10'');
      Ini.WriteInteger('test', 'int1', 123);
      Ini.UpdateFile;
      Result := LoadStringFromFile(AppIniFilePath);
      Ini.Free;
    end;

var
  S1, S2: String;
begin
  DeleteFile(AppIniFilePath);
  S1 := MakeTestIniFileCreateCRLF(TIniFile.Create(AppIniFilePath));
  DeleteFile(AppIniFilePath);
  S2 := MakeTestIniFileCreateCRLF(TAccessIniFile.Create(AppIniFilePath));
  UnitTest.Check(S1, S2);
  Clipboard.AsText := S1 + #13#10+ S2;

  Form1.Memo1.Text := S1;
  Form1.Memo2.Text := S2;
end;



procedure testIniCompare;
var
  MsgShow: Boolean;

  function MsgBoxShow(Msg: string): Boolean;
  begin
    Result := False;
    if MsgShow then
      if AppMsgBox(Msg, '', MB_YESNO) = IDYES then
      begin
        DoubleMemoCheck;
        Result := True;
      end;
  end;

begin
  MsgShow := False;
  UnitTest.AssertSwitch := True;
  UnitTest.Initialize;  UnitTest.WriteLog('Ini/AccessInir');
  testIniFileCreateCRLF;

  if MsgBoxShow('~܂'+#13+ UnitTest.Finalize) then
    raise Exception.Create('~܂');
end;

end.
