unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles, AccessIniFile, XPtest;

type
  TForm15 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form15: TForm15;

implementation

uses NkMemIniFile;

{$R *.dfm}

type
  TTestIniFile = TIniFile;

procedure MakeTestIniFile1;
var
  StrList: TStringList;
begin
  StrList := TStringList.Create;
  StrList.Add('[Option3]');
  StrList.Add('Name1=Value3-1');
  StrList.Add('Name2=Value3-2');
  StrList.Add('');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('');
  StrList.SaveToFile(ChangeFileExt(ParamStr(0), '.ini'));
  StrList.Free;
end;

function ResultTestIniFile1: String;
var
  StrList: TStringList;
begin
  StrList := TStringList.Create;
  StrList.Add('[Option3]');
  StrList.Add('Name1=Value3-1');
  StrList.Add('Name2=Value3-2');
  StrList.Add('');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('');
  StrList.Add('Name3=Value3-3');
  StrList.Add('Name4=Value3-4');
  Result := StrList.Text;
  StrList.Free;
end;

procedure MakeTestIniFile2;
var
  StrList: TStringList;
begin
  StrList := TStringList.Create;
  StrList.Add('[Option3]');
  StrList.Add('Name1=Value3-1');
  StrList.Add('Name2=Value3-2');
  StrList.Add('');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('');
  StrList.Add('[Option4]');
  StrList.Add('Name1=Value4-1');
  StrList.Add('Name2=Value4-2');
  StrList.SaveToFile(ChangeFileExt(ParamStr(0), '.ini'));
  StrList.Free;
end;

function ResultTestIniFile2: String;
var
  StrList: TStringList;
begin
  StrList := TStringList.Create;
  StrList.Add('[Option3]');
  StrList.Add('Name1=Value3-1');
  StrList.Add('Name2=Value3-2');
  StrList.Add('');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('Name3=Value3-3');
  StrList.Add('Name4=Value3-4');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('');
  StrList.Add('[Option4]');
  StrList.Add('Name1=Value4-1');
  StrList.Add('Name2=Value4-2');
  Result := StrList.Text;
  StrList.Free;
end;


procedure MakeTestIniFile3;
var
  StrList: TStringList;
begin
  StrList := TStringList.Create;
  StrList.Add('[Option3]');
  StrList.Add('Name1=Value3-1');
  StrList.Add('Name2=Value3-2');
  StrList.Add('');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('');
  StrList.SaveToFile(ChangeFileExt(ParamStr(0), '.ini'));
  StrList.Free;
end;

function ResultTestIniFile3: String;
var
  StrList: TStringList;
begin
  StrList := TStringList.Create;
  StrList.Add('[Option3]');
  StrList.Add('Name1=Value3-1');
  StrList.Add('Name2=Value3-2');
  StrList.Add('');
  StrList.Add(';Rg=CR[');
  StrList.Add(' ;Rg=CR[Cfg');
  StrList.Add(';Rg');
  StrList.Add(' ;RgCfg');
  StrList.Add('svs=CR[');
  StrList.Add(' svs=CR[Cfg');
  StrList.Add('Name3=Value3-3');
  StrList.Add('Name4=Value3-4');
  StrList.Add('svs');
  StrList.Add(' svsCfg');
  StrList.Add('');
  Result := StrList.Text;
  StrList.Free;
end;


procedure TForm15.Button1Click(Sender: TObject);
var
  Ini: TTestIniFile;
  SL: TStringList;
begin
  MakeTestIniFile1;
  Ini := TTestIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
  Ini.WriteString('Option3', 'Name3', 'Value3-3');
  Ini.WriteString('Option3', 'Name4', 'Value3-4');
  Ini.UpdateFile;
  SL := TStringList.Create;
  SL.LoadFromFile(ChangeFileExt(ParamStr(0), '.ini'));
  if not AnsiSameText(ResultTestIniFile1, SL.Text) then
  begin
    ShowMessage('eXgsi');
  end;
  SL.Free;
  Ini.Free;
end;


procedure TForm15.Button2Click(Sender: TObject);
var
  Ini: TTestIniFile;
  SL: TStringList;
begin
  MakeTesTIniFile2;
  Ini := TTestIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
  Ini.WriteString('Option3', 'Name3', 'Value3-3');
  Ini.WriteString('Option3', 'Name4', 'Value3-4');
  Ini.UpdateFile;
  SL := TStringList.Create;
  SL.LoadFromFile(ChangeFileExt(ParamStr(0), '.ini'));
  if not AnsiSameText(ResultTestIniFile2, SL.Text) then
  begin
    ShowMessage('eXgsi');
  end;
  SL.Free;
  Ini.Free;
end;


procedure TForm15.Button3Click(Sender: TObject);
var
  Ini: TTestIniFile;
  SL: TStringList;
begin
  MakeTesTIniFile3;
  Ini := TTestIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
  Ini.WriteString('Option3', 'Name3', 'Value3-3');
  Ini.WriteString('Option3', 'Name4', 'Value3-4');
  Ini.UpdateFile;
  SL := TStringList.Create;
  SL.LoadFromFile(ChangeFileExt(ParamStr(0), '.ini'));
  if not AnsiSameText(ResultTestIniFile3, SL.Text) then
  begin
    ShowMessage('eXgsi');
  end;
  SL.Free;
  Ini.Free;
end;


end.
